//+------------------------------------------------------------------+
//|                            Soho_Williams_VIX_fix_price_V1.20.mq4 |
//|                             |
//|                                                                  |
//+------------------------------------------------------------------+

/**********************************************************************
* This is a Synthetic VIX indicator as described in the December 2007 *
* issue of "Active Trader" magazine.  The indicator is also named the *
* "Williams VIX Fix" since Larry Williams is credited with the        *
* formula's discovery.                                                *
*                                                                     *
* This indicator was coded by Matthew Ebersviller.   
 and modified by sohocool the 07/01/2011   and 01/08/2015              *
**********************************************************************/




#property copyright "sohocool idea"
#property link       "http://sohocool-trading.blogspot.be/search/label/METATRADER"

#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1 clrLimeGreen
#property indicator_color2 clrLimeGreen
#property indicator_color3 clrRed
#property indicator_color4 clrRed

extern int VIX_Period = 21;
extern int FilterPeriod =5;
extern int PRICE =6;//3=low
extern int SignalPeriod=5;
extern int SignalMaMode=0;

double VixBuffer[],up[],BuffUpO[],BuffUpC[],BuffDwnO[],BuffDwnC[];

int Width_Histogram;

int init() {
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BuffUpO);
   SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,BuffUpC);  
   SetIndexStyle(2,DRAW_HISTOGRAM); 
   SetIndexBuffer(2,BuffDwnO);
   SetIndexStyle(3,DRAW_HISTOGRAM); 
   SetIndexBuffer(3,BuffDwnC);
   SetIndexBuffer(4,VixBuffer); 
   return(0);
}

int deinit()
  {
   return(0);
  }

int start()
  {
   int i, counted_bars=IndicatorCounted();
   
   if(Bars<=VIX_Period) return(0);
   
   if(counted_bars<1) {
      for(i=1;i<=VIX_Period;i++) {
         VixBuffer[Bars-i]=0.0;
      }
   }

   int limit=Bars-counted_bars;
   if (counted_bars>0) limit++;
   for(i=0; i<limit; i++)       VixBuffer[i]=VIX(i);
   for(i=0; i<limit; i++)
    {
    double VIX=VIX(i);
    double MA=iMAOnArray(VixBuffer,0,SignalPeriod,0,SignalMaMode,i);
    
    BuffUpO[i]=EMPTY;
    BuffUpC[i]=EMPTY;
    BuffDwnO[i]=EMPTY;
    BuffDwnC[i]=EMPTY;
    if(VIX>MA)
    {
    BuffUpO[i]=Open[i];
    BuffUpC[i]=Close[i];
    BuffDwnO[i]=EMPTY;
    BuffDwnC[i]=EMPTY;
    }
    if(VIX<MA)
    {
    BuffUpO[i]=EMPTY;
    BuffUpC[i]=EMPTY;
    BuffDwnO[i]=Open[i];
    BuffDwnC[i]=Close[i];
    }
    }
      
   return(0);
  }
//+------------------------------------------------------------------+

double VIX(int shift) {
  double highClose,price,vix;
  highClose = Close[iHighest(NULL,0,MODE_CLOSE,VIX_Period,shift)];
  price = iMA(NULL,0,FilterPeriod,0,3,PRICE,shift);
  vix = -100 *(highClose - price) / highClose ;
  return (vix);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         // Event identifier  
                  const long& lparam,   // Event parameter of long type
                  const double& dparam, // Event parameter of double type
                  const string& sparam) // Event parameter of string type
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
     }
      WidthAuto();
  }
//+------------------------------------------------------------------+
void WidthAuto()
  {
   long result=-1;
   int a;
   result=ChartGetInteger(0,CHART_SCALE,0);

   a=result;
   switch(a)
     {
      case 0: Width_Histogram=0;
      break;

      case 1: Width_Histogram=1;
      break;

      case 2: Width_Histogram=2;
      break;

      case 3: Width_Histogram=3;
      break;

      case 4: Width_Histogram=7;
      break;

      case 5: Width_Histogram=15;
      break;

      break;
      default : Width_Histogram=3;
     }
     
   SetIndexStyle(0,DRAW_HISTOGRAM,0,Width_Histogram);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,Width_Histogram);     
   SetIndexStyle(2,DRAW_HISTOGRAM,0,Width_Histogram);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,Width_Histogram);

  }
//+------------------------------------------------------------------+
  